=== debian/changelog ===
condor (8.4.11~dfsg.1-2) unstable; urgency=medium

  * List additional global symbols for new gsoap version(Closes: #868905).
    Thanks to Michael Hudson-Doyle <michael.hudson@canonical.com>
  * Add build conflict to prevent pulling in cream on raspian.
    Thanks to Peter Green <plugwash@p10link.net>

 -- Tim Theisen <tim@cs.wisc.edu>  Fri, 18 Aug 2017 22:39:59 -0500

condor (8.4.11~dfsg.1-1) unstable; urgency=medium

  * New upstream bugfix release.
    - Various bugfixes for a number of HTCondor subsystems
      http://research.cs.wisc.edu/htcondor/manual/v8.4.11/10_3Stable_Release.html
  * Add Tim Theisen as a maintainer.
  * Remove Brian Lin as a maintainer.

 -- Tim Theisen <tim@cs.wisc.edu>  Wed, 25 Jan 2017 09:45:20 -0600
